package hu.bme.mit.bookorder;

import hu.bme.mit.bookorder.book.Book;
import hu.bme.mit.bookorder.book.Genre;
import hu.bme.mit.bookorder.book.Person;

import java.util.Arrays;
import java.util.Collections;

public class BookBidderTest {

	public static void main(String[] args) {
		BookBidder bookBidder = new BookBidder();
		
		Iterable<Object> testElements = makeTestElements();
		bookBidder.bidForBooks(testElements);
	}
	
	private static Iterable<Object> makeTestElements() { // !!
		Person orwell = new Person("George Orwell", 1903);
		Person delphine = new Person("Delphine Minoui", 1974);
		Person nujood = new Person("Nujood Ali", 1998);
		
		Book animal_farm = new Book(
				"Animal Farm", 
				/* authors */ Arrays.asList(orwell),
				/* editors */ Collections.<Person>emptySet(),
				"Secker and Warburg", 1945, 
				/* pages */ 112,
				/* copies sold (if known) */ 20000000,
				Genre.SCIENCE_FICTION);
		Book nineteen_eighty_four = new Book(
				"Nineteen Eighty-Four", 
				/* authors */ Arrays.asList(orwell),
				/* editors */ Collections.<Person>emptySet(),
				"Secker and Warburg", 1949, 
				/* pages */ 326,
				/* copies sold (if known) */ 25000000, 
				Genre.SCIENCE_FICTION);
		Book age10_divorced = new Book(
				"I Am Nujood, Age 10 and Divorced", 
				/* authors */ Arrays.asList(nujood, delphine),
				/* editors */ Collections.<Person>emptySet(),
				"Michel Lafon", 2009, 
				/* pages */ 188,
				/* copies sold (if known) */ null, 
				Genre.BIOGRAPHY);
		
		return Arrays.asList(
					orwell, delphine, nujood,
					animal_farm, nineteen_eighty_four, age10_divorced
				);
	}
}
