/**
 * 
 */
package hu.bme.mit.bookorder.book;

import java.util.Arrays;
import java.util.Collection;

/**
 * @author Administrator
 *
 */
public class Book {
	private String title;
	private Collection<Person> authors;
	private Collection<Person> editors;
	private String publisher;
	private int publicationYear;
	private int numberOfPages;
	private Integer numberOfCopiesSold;
	private Genre genre;
	private Double price = null;
	
	public Book(String title, Collection<Person> authors, 
			Collection<Person> editors, String publisher, int publicationYear, 
			int numberOfPages, Integer numberOfCopiesSold, Genre genre) {
		super();
		this.title = title;
		this.authors = authors;
		this.editors = editors;
		this.publisher = publisher;
		this.publicationYear = publicationYear;
		this.numberOfPages = numberOfPages;
		this.numberOfCopiesSold = numberOfCopiesSold;
		this.genre = genre;
	}
	public String getTitle() {
		return title;
	}
	public Collection<Person> getAuthors() {
		return authors;
	}
	public Collection<Person> getEditors() {
		return editors;
	}
	public String getPublisher() {
		return publisher;
	}
	public int getPublicationYear() {
		return publicationYear;
	}
	public int getNumberOfPages() {
		return numberOfPages;
	}
	public Integer getNumberOfCopiesSold() {
		return numberOfCopiesSold;
	}
	public Double getPrice() {
		return price;
	}
	public void setPrice(Double price) {
		this.price = price;
	}
	public Genre getGenre() {
		return genre;
	}
	
	@Override
	public String toString() {
		String authorList = Arrays.toString(authors.toArray()).replaceAll("[\\[\\]]", "");
		return String.format("%s - %s (%s, %d) @ $%.2f", 
				authorList, title, 
				publisher, publicationYear, 
				price == null ? Double.NaN : price);
	}
}
